//
//  PithosContainerNode.h
//  pithos-macos
//
// Copyright 2011-2012 GRNET S.A. All rights reserved.
//
// Redistribution and use in source and binary forms, with or
// without modification, are permitted provided that the following
// conditions are met:
// 
//   1. Redistributions of source code must retain the above
//      copyright notice, this list of conditions and the following
//      disclaimer.
// 
//   2. Redistributions in binary form must reproduce the above
//      copyright notice, this list of conditions and the following
//      disclaimer in the documentation and/or other materials
//      provided with the distribution.
// 
// THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GRNET S.A OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
// USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
// AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// The views and conclusions contained in the software and
// documentation are those of the authors and should not be
// interpreted as representing official policies, either expressed
// or implied, of GRNET S.A.

#import "PithosNode.h"
@class ASIPithos;
@class ASIPithosContainer;
@class ASIPithosContainerRequest;

@interface PithosContainerNode : PithosNode {
    ASIPithos *pithos;
    ASIPithosContainer *pithosContainer;
    
    NSMutableArray *objects;
    ASIPithosContainerRequest *containerRequest;
    NSString *prefix;
    
    ASIPithosContainerRequest *applyMetadataContainerRequest;
    ASIPithosContainerRequest *refreshMetadataContainerRequest;
    
    NSString *policyVersioning;
    NSNumber *policyQuota;
}

- (id)initWithPithos:(ASIPithos *)aPithos pithosContainer:(ASIPithosContainer *)aPithosContainer;
- (id)initWithPithos:(ASIPithos *)aPithos pithosContainer:(ASIPithosContainer *)aPithosContainer icon:(NSImage *)anIcon;
- (id)initWithPithos:(ASIPithos *)aPithos containerName:(NSString *)aContainerName;
- (id)initWithPithos:(ASIPithos *)aPithos containerName:(NSString *)aContainerName icon:(NSImage *)anIcon;

@property(nonatomic, strong) ASIPithos *pithos;
@property(nonatomic, strong) ASIPithosContainer *pithosContainer;
@property(nonatomic, strong) NSString *prefix;
@property(nonatomic, strong) NSString *policyVersioning;
@property(nonatomic, strong) NSNumber *policyQuota;

- (void)applyInfo;
- (void)refreshInfo;
- (void)setLimitedPithosContainer:(ASIPithosContainer *)aPithosContainer;

@end